; I2CScan - an utility which scans the I2C bus for devices
; Version 0.99, 14.1.1998
; Copyright (C) 1998 Osma Suominen <ozone@clinet.fi>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
; The file COPYING, which should have been included with this source file,
; contains the GNU General Public License, which applies to this program.
;
; Look in README.TXT for usage instructions.



#include "ti-85.h"



; Variables in text memory
I2CAddress = $80DF
I2CSpeed   = $80E0

.org 0
.db "I2C Scanner",0

        ROM_CALL(CLEARLCD)

        xor a
        ld (I2CAddress),a       ; Own addr = 0 (no slave routines)
        ld (CURSOR_ROW),a
        ld (CURSOR_COL),a
        ld a,$10
        ld (I2CSpeed),a         ; Quite slow a speed

        ld hl,(PROGRAM_ADDR)
        ld de,GenCallText
        add hl,de
        ROM_CALL(D_ZT_STR)

        ld a,$ff
        ld b,0
        ld d,0
        CALL_(MI2C)             ; Ping to General call address
        ld hl,(PROGRAM_ADDR)
        ld de,No
        jr c,GenCallDisp
        ld de,Yes
GenCallDisp:
        add hl,de
        ROM_CALL(D_ZT_STR)

        CALL_(Linefeed)

        ld hl,(PROGRAM_ADDR)
        ld de,DevFoundText
        add hl,de
        ROM_CALL(D_ZT_STR)
        CALL_(Linefeed)
        ld d,16                 ; Start at addr 16
        ld b,0                  ; Data length = 0
DevLoop:
        call GET_KEY            ; Exit if Enter is pressed
        cp $37
        ret z
        ld h,0
        ld l,d
        push de
        ROM_CALL(D_HL_DECI)
        xor a
        ld (CURSOR_COL),a
        pop de
        ld a,$f0
        CALL_(MI2C)
        jr c,NoLinefeed
        CALL_(Linefeed)
NoLinefeed:
        inc d
        inc d
        cp d
        jr nz,DevLoop
        
        ld hl,(PROGRAM_ADDR)
        ld de,PressText
        add hl,de
        ROM_CALL(D_ZT_STR)
        CALL_(AnyKeyLoop)
        ret                     ; Exit back to ZShell

Linefeed:
        xor a
        ld (CURSOR_COL),a
        ld a,(CURSOR_ROW)
        inc a
        cp 8
        jr z,More
        ld (CURSOR_ROW),a
        ret

More:
        ld hl,(PROGRAM_ADDR)
        ld de,MoreText
        add hl,de
        ROM_CALL(D_ZT_STR)
        CALL_(AnyKeyLoop)
        ROM_CALL(CLEARLCD)
        xor a
        ld (CURSOR_ROW),a
        ret

AnyKeyLoop:
        halt
        call GET_KEY
        cp 0
        jr z,AnyKeyLoop
        ret

GenCallText:
.db "General call ACK:",0
Yes:
.db "Yes",0
No:
.db "No",0
DevFoundText:
.db "Devices found:",0
PressText:
.db "Press any key",0
MoreText:
.db "-- More --",0

#define NO_RAW

#include "master.asm"

.end
